/******************************************************************
 *
 * Name:	Plugin_procs.c
 * 
 * Description:
 * 
 * Author:	Tomasz Stachowiak
 *
 * Date:	18/07/96
 *
 * Change Log:
 *
 ********************************************************************/
#include <stdio.h>
#include <sys/types.h>

#include <dve/dve.h>

#include "TSVideoPluginRaw.h"
#include "VideoPluginProtocol.h"
#include "Video.h"

extern DveSession dveSession;       /* global variables */
Video video;


/**********************************************************************
 *
 * Functions kept for OpenDVE_procs.c compatibility
 *
 *********************************************************************/
void QueryPluginStatus(DveConfParticipant *part)
{
}

void ProcessClipboardData(char *format, char *data, int length)
{
}



/********************************************************************
 *
 * Frames management
 *
 *******************************************************************/

void
SendInitMsg()
{
   videoPluginMessageStructure *msg;

   msg = (videoPluginMessageStructure *) dveMallocDataPacket(dveSession,
                                          sizeof(videoPluginMessageStructure));
   if (!msg)
   {
     printf("Message allocation error\n");
     return;
   }
 

   if(SendPluginMessage(dveSession,
                           VIDEO_PLUGIN_PORT, INIT, msg,
                           sizeof(videoPluginMessageStructure)) < 0)
		printf("Sending failure\n");

   return;
}


void
SendFrame(char *buf)
{
   videoPluginMessageStructure *msg;

   msg = (videoPluginMessageStructure *) dveMallocDataPacket(dveSession,
                                          sizeof(videoPluginMessageStructure));
   if (!msg)
   {
     printf("Message allocation error\n");
     return;
   }
 
   memcpy(msg->frame, buf, FRAME_SIZE);


   if(SendPluginMessage(dveSession,
                           VIDEO_PLUGIN_PORT, VIDEO, msg,
                           sizeof(videoPluginMessageStructure)) < 0)
		printf("Sending failure\n");

   return;
}


/************************************************************************
 *
 * Conference mangement functions
 *
 ***********************************************************************/
void 
MemberLeft(DveConfParticipant member)
{
   fprintf(stderr, "User Left the Conference - %s@%s (%s)\n",
                    member.userName, member.hostName,
                    inet_ntoa(*(struct in_addr*)&((member.addr.v3))));
}

void 
MemberAdded(DveConfParticipant member)
{
   fprintf(stderr, "User Added to Conference - %s@%s (%s)\n",
                    member.userName, member.hostName,
                    inet_ntoa(*(struct in_addr*)&((member.addr.v3))));
}


/**************************************************************************
 *
 * Function processing incoming messages
 *
 *************************************************************************/
void 
ProcessPluginMessage(u_int32 messageType, void *data, DveUserHandle sender) 
{
   videoPluginMessageStructure message;
   memcpy(&message, data, sizeof(videoPluginMessageStructure));

   switch (messageType){
      case VIDEO:
         video.put_frame(message.frame);
	 break;
   }
}


/*********************************************************************
 *
 * Plugin management functions
 *
 ********************************************************************/
void 
ShowPlugin(void)
{
   fprintf(stderr, "ShowPlugin\n");
}

void 
HidePlugin(void)
{
   fprintf(stderr, "HidePlugin\n");
}

void 
CleanupPlugin(void)
{
}


/************************** END Plugin_procs.c **************************/






